/***************************************************************************
                          dlgxmlattribute.h  -  description
                             -------------------
    begin                : Fre Jul 12 2002
    copyright            : (C) 2002, 2003 by The KXMLEditor Team
    email                : lvanek@eanet.cz
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

#ifndef DLGXMLATTRIBUTE_H
#define DLGXMLATTRIBUTE_H

#include "dlgxmlattributebase.h"

#include <qdom.h>

class DlgXMLAttribute : public DlgXMLAttributeBase
{
		Q_OBJECT

	public:
		DlgXMLAttribute( QWidget * pParent = 0, const char * pszName = 0, bool fModal = true, WFlags fl = 0 );

	public slots:
		/**
		 * To be used for adding an attribute to the given XML element.
		 *
		 * If OK was pressed, a new attribute is appended to the given
		 * element with the data entered in this dialog.
		 *
		 * @return see @ref QDialog::exec
		 */
		int exec( QDomElement & domElement );

		/**
		 * Clears the dialogs widgets.
		 */
		void clearDialog();

	protected slots:
		/**
		 * Don't use this function directly, it's for internal use only.
		 * Use one of the other @ref DlgXMLAttribute::exec functions instead.
		 */
		int exec();
		/**
		 * Called, when the data in the edit lines @ref DlgXMLAttributeBase::m_pEditQName
		 * @ref DlgXMLAttributeBase::m_pEditValue is changed.
		 * Disables the OK button, if the given strings are empty.
		 */
		void slotDataChanged();
};

#endif
