/***************************************************************************
                          dlgxmlprocinstr.cpp  -  description
                             -------------------
    begin                : Mit Apr 24 2002
    copyright            : (C) 2002, 2003 by The KXMLEditor Team
    email                : lvanek@eanet.cz
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

#include "dlgxmlprocinstr.h"

#include <qlabel.h>
#include <qcombobox.h>
#include <qpushbutton.h>
#include <qtextedit.h>

#include <klineedit.h>
#include <kdebug.h>
#include <klocale.h>
#include <kmessagebox.h>

DlgXMLProcInstr::DlgXMLProcInstr( QWidget * pParent, const char * pszName, bool fModal, WFlags fl )
	: DlgXMLProcInstrBase( pParent, pszName, fModal, fl )
{
  // signals and slots connections
  connect( m_pBtnOK, SIGNAL( clicked() ), this, SLOT( slotAccept() ) );
  connect( m_pEditData, SIGNAL(textChanged()), this, SLOT(slotChanged()) );
}

void DlgXMLProcInstr::fillDialog( const QDomProcessingInstruction & domProcInstr )
{
	m_pEditTarget->setText( domProcInstr.target() );
	m_pEditData->setText( domProcInstr.data() );
}

void DlgXMLProcInstr::clearDialog()
{
	m_pEditTarget->clear();
	m_pEditData->clear();
}

void DlgXMLProcInstr::fillProcInstr( QDomProcessingInstruction & domProcInstr )
{
	domProcInstr.setData(m_pEditData->text());
}

int DlgXMLProcInstr::exec( QDomProcessingInstruction & domProcInstr )
{
	m_pComboInsert->hide();
	m_pComboInsert->setDisabled(true);
	m_pLblInsert->hide();
	m_pLblInsert->setDisabled(true);

	m_pEditTarget->setDisabled(true);
	fillDialog( domProcInstr );

	int iReturn = exec();
	if ( iReturn == Accepted )
		fillProcInstr( domProcInstr );

	return iReturn;
}

int DlgXMLProcInstr::exec( QDomNode & domParentNode, QDomProcessingInstruction & domNewProcInstr )
{
	if ( domParentNode.isNull() )
	{
		kdError() << k_funcinfo << " The given parent object is empty." << endl;
		return Rejected;
	}
	else if ( ( ! domParentNode.isElement() ) && ( ! domParentNode.isDocument() ) )
	{
		kdError() << k_funcinfo << " The given parent object is of wrong type (" << domParentNode.nodeType() << ")." << endl;
		return Rejected;
	}

	if ( domParentNode.isDocument() )
	{
		m_pComboInsert->hide();
		m_pComboInsert->setDisabled(true);
		m_pLblInsert->hide();
		m_pLblInsert->setDisabled(true);
	}
	m_pEditTarget->setEnabled(true);
	clearDialog();

	int iReturn = exec();
	if ( iReturn == Accepted )
	{
		domNewProcInstr = domParentNode.ownerDocument().createProcessingInstruction( m_pEditTarget->text(), m_pEditData->text() );

		if ( m_pComboInsert->currentItem() == 0 )
		{                                         // insert as first child
			QDomNode domFirstChildNode = domParentNode.firstChild();
			if ( domFirstChildNode.isNull() )
				domParentNode.appendChild( domNewProcInstr ); // no childs yet -> simply append
			else
				domParentNode.insertBefore( domNewProcInstr, domFirstChildNode );
		}
		else                                      // insert as last child
			domParentNode.appendChild( domNewProcInstr );
	}

	return iReturn;
}

int DlgXMLProcInstr::exec()
{
	if ( m_pEditTarget->text().isEmpty() )
		m_pBtnOK->setEnabled(false);
	else
		m_pBtnOK->setEnabled(true);

	if ( m_pEditTarget->isEnabled() )
		m_pEditTarget->setFocus();
	else
		m_pEditData->setFocus();

	m_pBtnOK->setDefault(true);

	return DlgXMLProcInstrBase::exec();
}

void DlgXMLProcInstr::slotChanged()
{
	if ( m_pEditData->text().isEmpty() )
		m_pBtnOK->setDisabled(true);
	else
		m_pBtnOK->setEnabled(true);
}

/** Called when user press OK button */
void DlgXMLProcInstr::slotAccept()
{
  if(m_pEditTarget->text() == "xml")
    { KMessageBox::sorry(this, i18n("Pleasse use menu item XML -> Version and encoding for this processing instruction !"));
			return;
		}
  
  accept();
}
