/***************************************************************************
                          dlgxmlspecprocinstr.h  -  description
                             -------------------
    begin                : Ne ?ec 6 2003
    copyright            : (C) 2003 by The KXMLEditor Team
    email                : lvanek@eanet.cz
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

#ifndef DLGXMLSPECPROCINSTR_H
#define DLGXMLSPECPROCINSTR_H

#include <qwidget.h>
#include <qdom.h>
#include <dlgxmlspecprocinstrbase.h>

/**
  *@author Lumir Vanek
  */

class DlgXMLSpecProcInstr : public DlgXMLSpecProcInstrBase
{
   Q_OBJECT
   
public: 
	DlgXMLSpecProcInstr(QWidget *parent=0, const char *name=0);
	~DlgXMLSpecProcInstr();

  /**
		 * To be used for editing the given proc.instruction,
     * Updates the given proc.instr. with the data entered by the user
		 * (if OK was pressed).
		 *
		 * @return see @ref QDialog::exec
		 */
    int exec( QDomProcessingInstruction & domProcInstr );

    /**
		 * To be used for inserting a proc.instruction as child
		 * of the given parent node.
		 * If OK was pressed, a new proc.instr. is created with the entered
		 * data and gets set as a child of the given parent node. The
		 * new proc.instr. can be accessed via domNewProcInstr.
		 *
		 * @return see @ref QDialog::exec
		 */
		int exec( QDomNode & domParentNode, QDomProcessingInstruction & domNewProcInstr );

//    protected:
		/**
		 * Don't use this function directly, it's for internal use only.
		 * Use one of the other @ref DlgXMLProcInstr::exec functions instead.
		 */
		int exec();

    /**
		 * Fills the dialogs widgets with the data from the given proc.instruction.
		 */
		void fillDialog( const QDomProcessingInstruction & domProcInstr );

    /**
		 * Updates the given proc.instr. with the data entered in the dialogs widgets.
		 */
		void fillProcInstr( QDomProcessingInstruction & domProcInstr );
    void fillDialog(const QString& version, const QString& encoding);
    QString getData();

    protected slots:
    
		/** Called when user press OK button */
    void slotAccept();

};

#endif
